#coding:utf-8
import sys, os, select, tty, fcntl, time, termios

class TT(object): # Класс для работы с терминалом в неблокирующем режиме
  def __init__(self, timeout):
    self._timeout = timeout
    self._fd = sys.stdin.fileno()
    self._old_settings = new_settings = termios.tcgetattr(self._fd)
    self._poller = select.poll()
    self._poller.register(sys.stdin, select.POLLIN)
    tty.setcbreak(sys.stdin)
    fcntl.fcntl(self._fd, fcntl.F_SETFL, os.O_NONBLOCK)
  def __del__(self): # В деструкторе - возврат к старому терминалу
    termios.tcsetattr(self._fd, termios.TCSAFLUSH, self._old_settings)
  def kbhit(self): # Проверка нажата ли клавиша
    return self._poller.poll(self._timeout)
  def getch(self): # Возвращает введенный символ
    ch = sys.stdin.read(1)
    if ord(ch) == 27: # Esc-последовательность-выберем остаток в буфере
      sys.stdin.read()
    return ch

