#coding:utf-8
import sys, os, time
import math, collections
import sens, contr, kbh
"""Файл misc.py
   Функции инициализации, ведения журнала и вывода на экран     
   OldBean, 24.03.2017"""
#-------------------------------------------------------------------------------
# Создание и тестирование объектов датчиков и контроллеров
#-------------------------------------------------------------------------------
def test(tids, vs, ps, teh, sd):
  Ts = sens.DS18B20.Ts() # Опросим все датчики температуры на шине 1-Wire
  flag = False
  for id in tids:
    if Ts.get(id) != None: print "Датчик т-ры, ID = 0x%012x :% 7.3f°C - OK" % (id, Ts[id])
    else: 
      print "Датчик с ID = 0x%012x отсутствует или неисправен" % (id)
      flag = True
  if flag:
    print "Один или более датчиков DS18B20 отсутствуют или неисправны. Завершение работы."
    return False

  if vs != None: # Датчик в наличии и функционирует
    V = vs.V
    if V > 100: print "Действующее напряжение сети %d В - OK" % (V)
    else:
      print "Слишком низкое напряжение сети. Завершение работы."
      return False
  else:
    print "Отсутствует или неисправен датчик RMS напряжения сети. Завершение работы."
    return False

  if ps != None: # Датчик в наличии и функционирует
    print "Атмосферное давление: \t%5.1f мм.рт.ст. - OK" % (ps.P)
    print "Температура окружающей среды:\t%5.2f°C" % (ps.T)
  else:
    print "Отсутствует или неисправен датчик атмосферного давления. Завершение работы."
    return False

  if teh == None:
    print "Контроллер ТЭНа отсутствует или неисправен. Завершение работы."
    return False
  print "Контроллер ТЭНа - OK"

  if sd == None:
    print "Контроллер клапана отбора отсутствует или неисправен. Завершение работы."
    return 0
  print "Контроллер клапана отбора - OK"
  
  return True
#-------------------------------------------------------------------------------
""" Разбираемся с файлом журнала - продолжить старый, если есть, или начать новый, 
    если файла журнала нет или слишком мал ( < 128 байтов)"""
#-------------------------------------------------------------------------------
def logOpen(fn):
  tst = rst = time.time()
  if os.path.exists(fn) and os.path.getsize(fn) > 127: 
    log = open(fn, "r") # Нужно прочитать последнюю строку
    log.seek(-127, 2) # Встанeм немного недоходя до конца файла
    for line in open(fn, "r"): # и считаем последнюю строку
      last_line = line
    prevStopTime = float(last_line.split()[1])
    tst -= prevStopTime*60.0 # Локальное время будет продолжаться с конца
                             # предыдущей сессии
    log.close()
    log = open(fn, "a") # А теперь откроем его уже для добавления
  else: # В противном случае создаем новый файл журнала
    log = open(fn, "w")
  return (log, tst, rst)
#-------------------------------------------------------------------------------
# Вывод информации в файл журнала
#-------------------------------------------------------------------------------
def logWrite(log, now, tst, rst, mode, tids, Ts, cW, P, Q, F, ssFlag, par):
  dtm = (now - tst)/60.0; dtrm = (now - rst)/60.0
  s = time.strftime("%y.%m.%d.%H.%M.%S")
  s += "% 7.2f % 7.2f %d" % (dtm, dtrm, mode)
  for id in tids: # Текущие температуры
    s +=  "% 7.3f" % (Ts[id])
  s +=  " %4d" % (cW) # Мощность нагрева
  s += "% 5.1f" % (P) # Давление
  s += " %4d" % (Q)
  s += " %5d" % (F) # Расход
  s += par

  log.write(s + "\n"); log.flush()
#-------------------------------------------------------------------------------
# Вывод информации на терминал
#-------------------------------------------------------------------------------
def prnt(now, tst, rst, mode, tids, Ts, cW, P, Q, F, ssFlag, par):
  dtm = (now - tst)/60.0; dtrm = (now - rst)/60.0
  ss = "% 7.2f % 7.2f\x1b[33m %d\x1b[0m" % (dtm, dtrm, mode)
  for id in tids: # Текущие температуры
    if id == tids[1]: ss += "\x1b[32m% 7.3f\x1b[0m" % (Ts[id])
    elif id == tids[3]: ss += "% 6.1f" % (Ts[id])
    else: ss += "% 6.2f" % (Ts[id])
  ss += "\x1b[31m %4d\x1b[0m" % (cW) # Мощность нагрева
  ss += "% 5.1f" % (P) # Давление

  if ssFlag: # Регулирование активировано - подсветка
    ss += "\x1b[35m %4d\x1b[0m" % (Q);
  else:
    ss += " %4d" % (Q);
  ss += " %5d" % (F) # Расход

  ss += par

  print ss
#-------------------------------------------------------------------------------

